Merge "Apply NSDriver patch for neutron for all FD.io scenarios"
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
39       else
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
41       fi
42     else
43       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
44     fi
45     SDN_IMAGE=opendaylight
46   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
47     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
48     SDN_IMAGE=opendaylight
49   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
50     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
51     exit 1
52     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
53     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
54     #else
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
56     #fi
57     #SDN_IMAGE=onos
58   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
59     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
60     exit 1
61   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
62     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
63     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
64       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
65     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
66       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
67     fi
68     SDN_IMAGE=opendaylight
69   else
70     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
71     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
72     exit 1
73   fi
74
75   # Enable Tacker
76   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
77     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
78   fi
79
80   # Enable Congress
81   if [ "${deploy_options_array['congress']}" == 'True' ]; then
82     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
83   fi
84
85   # Enable Real Time Kernel (kvm4nfv)
86   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
87     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
88   fi
89
90   # Make sure the correct overcloud image is available
91   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
92       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
93       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
94       exit 1
95   fi
96
97   echo "Copying overcloud image to Undercloud"
98   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
99   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
100
101   # disable neutron openvswitch agent from starting
102   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
103       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
104       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
105       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
106                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
107                                                -a overcloud-full.qcow2
108 EOI
109   fi
110
111   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
112       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
113       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
114       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
115                                                --run-command "systemctl enable zrpcd" \
116                                                -a overcloud-full.qcow2
117 EOI
118   fi
119
120   # Install ovs-dpdk inside the overcloud image if it is enabled.
121   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
122     # install dpdk packages before ovs
123     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
124
125     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
126       cat << EOF > vfio_pci.modules
127 #!/bin/bash
128 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
129 EOF
130
131       cat << EOF > uio_pci_generic.modules
132 #!/bin/bash
133 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
134 EOF
135
136       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
137                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
138                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
139                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
140                                                -a overcloud-full.qcow2
141
142       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
143         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
144       fi
145
146 EOI
147
148   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
149     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
150     exit 1
151   fi
152
153   if [ "$debug" == 'TRUE' ]; then
154     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
155   fi
156
157   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
158   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
159     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
160          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
161                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
162                                                   -a overcloud-full.qcow2
163 EOI
164   fi
165
166   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
167   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
168     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
169       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
170                                                -a overcloud-full.qcow2
171 EOI
172     # Configure routing node for odl_l3-fdio
173     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
174       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
175         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
176 EOI
177     fi
178   fi
179
180   if [ -n "${deploy_options_array['performance']}" ]; then
181     ovs_dpdk_perf_flag="False"
182     for option in "${performance_options[@]}" ; do
183       arr=($option)
184       # use compute's kernel settings for all nodes for now.
185       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
186         kernel_args+=" ${arr[2]}=${arr[3]}"
187       fi
188       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
189          eval "${arr[2]}=${arr[3]}"
190          ovs_dpdk_perf_flag="True"
191       fi
192     done
193
194     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
195       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
196       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
197       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
198 EOI
199
200     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
201       for ovs_option in ${!ovs_option_heat_arr[@]}; do
202         if [ -n "${!ovs_option}" ]; then
203           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
204             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
205 EOI
206         fi
207       done
208     fi
209   fi
210
211   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
212     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
213       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
214         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
215           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
216 EOI
217       else
218         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
219         exit 1
220       fi
221     fi
222   fi
223
224   # Set ODL version accordingly
225   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
226     case "${deploy_options_array['odl_version']}" in
227       beryllium) odl_version=''
228               ;;
229       boron)  odl_version='boron'
230               ;;
231       carbon) odl_version='master'
232               ;;
233       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
234          exit 1
235          ;;
236     esac
237
238     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
239       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
240                                                --run-command "yum -y install /root/${odl_version}/*" \
241                                                -a overcloud-full.qcow2
242 EOI
243   fi
244
245   # Override ODL if FDIO and ODL L2
246   if [[ "${deploy_options_array['vpp']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['sdn_l3']}" == "False" ]]; then
247     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
248          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
249                                                   --run-command "yum -y install /root/fdio_l2/opendaylight*.rpm" \
250                                                   -a overcloud-full.qcow2
251 EOI
252   fi
253
254   # check if ceph should be enabled
255   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
256     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
257   fi
258
259   # get number of nodes available in inventory
260   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
261   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
262
263   # check if HA is enabled
264   if [[ "$ha_enabled" == "True" ]]; then
265     if [ "$num_control_nodes" -lt 3 ]; then
266       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
267       exit 1
268     else
269      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
270      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
271      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
272     fi
273   else
274     if [ "$num_control_nodes" -lt 1 ]; then
275       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
276       exit 1
277     fi
278   fi
279
280   if [ "$num_compute_nodes" -le 0 ]; then
281     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
282     exit 1
283   else
284     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
285     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
286   fi
287
288   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
289
290   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
291   if [[ "$virtual" == "TRUE" ]]; then
292      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
293   fi
294
295   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
296
297   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
298 # Create a key for use by nova for live migration
299 echo "Creating nova SSH key for nova resize support"
300 ssh-keygen -f nova_id_rsa -b 1024 -P ""
301 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
302 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
303 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
304 mv -f opnfv-environment-new.yaml ${ENV_FILE}
305
306 source stackrc
307 set -o errexit
308 # Workaround for APEX-207 where sometimes swift proxy is down
309 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
310   sudo systemctl restart openstack-swift-proxy
311 fi
312 echo "Uploading overcloud glance images"
313 openstack overcloud image upload
314
315 echo "Configuring undercloud and discovering nodes"
316 openstack baremetal import --json instackenv.json
317
318 if [[ -z "$virtual" ]]; then
319   openstack baremetal introspection bulk start
320   if [[ -n "$root_disk_list" ]]; then
321     openstack baremetal configure boot --root-device=${root_disk_list}
322   else
323     openstack baremetal configure boot
324   fi
325 else
326   openstack baremetal configure boot
327 fi
328
329 echo "Configuring flavors"
330 for flavor in baremetal control compute; do
331   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
332   if openstack flavor list | grep \${flavor}; then
333     openstack flavor delete \${flavor}
334   fi
335   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
336   if ! openstack flavor list | grep \${flavor}; then
337     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
338   fi
339 done
340 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
341 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
342 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
343 echo "Configuring nameserver on ctlplane network"
344 dns_server_ext=''
345 for dns_server in ${dns_servers}; do
346   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
347 done
348 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
349 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
350 echo "Executing overcloud deployment, this should run for an extended period without output."
351 sleep 60 #wait for Hypervisor stats to check-in to nova
352 # save deploy command so it can be used for debugging
353 cat > deploy_command << EOF
354 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
355 EOF
356 EOI
357
358   if [ "$interactive" == "TRUE" ]; then
359     if ! prompt_user "Overcloud Deployment"; then
360       echo -e "${blue}INFO: User requests exit${reset}"
361       exit 0
362     fi
363   fi
364
365   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
366 source stackrc
367 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
368 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
369   $(typeset -f debug_stack)
370   debug_stack
371   exit 1
372 fi
373 EOI
374
375   # Configure DPDK and restart ovs agent after bringing up br-phy
376   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
377     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
378 source stackrc
379 set -o errexit
380 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
381 echo "Checking DPDK status and bringing up br-phy on \$node"
382 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
383 set -o errexit
384 sudo dpdk-devbind -s
385 sudo ifup br-phy
386 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
387   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
388   sudo systemctl restart neutron-openvswitch-agent
389 fi
390 EOF
391 done
392 EOI
393   fi
394
395   if [ "$debug" == 'TRUE' ]; then
396       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
397 source overcloudrc
398 echo "Keystone Endpoint List:"
399 openstack endpoint list
400 echo "Keystone Service List"
401 openstack service list
402 EOI
403   fi
404 }